/*
  File autogenerated by gengetopt version 2.12.1
  generated with the following command:
  gengetopt --input=simpleview_cmd.ggo --file-name=simpleview_cmd --unamed-opts 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "simpleview_cmd.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->verbosity_given = 0 ;
  args_info->width_given = 0 ;
  args_info->height_given = 0 ;
  args_info->basename_given = 0 ;
  args_info->keys_given = 0 ;
  args_info->list_given = 0 ;
  args_info->type_given = 0 ;
  args_info->waypoints_given = 0 ;
  args_info->interval_given = 0 ;
  args_info->percent_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->verbosity_arg = 0 ;
  args_info->width_arg = 800 ;
  args_info->height_arg = 600 ;
  args_info->basename_arg = gengetopt_strdup ("moose_poop-");
  args_info->type_arg = gengetopt_strdup ("png");
  args_info->waypoints_arg = NULL;
  args_info->interval_arg = 0.25 ;
  args_info->percent_arg = 0.1 ;
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
  "  Coin/SimVoleon viewer of OpenInventor, VRML, and Voxel data\n"
  "\n"
  "Usage: %s [OPTIONS]... [FILES]...\n", CMDLINE_PARSER_PACKAGE);
  printf("\n");
  printf("%s\n","  -h, --help                Print help and exit");
  printf("%s\n","  -V, --version             Print version and exit");
  printf("%s\n","  -v, --verbosity=INT       Set the verbosity level (0=quiet 10=verbose 20=\n                              bombastic)  (default=`0')");
  printf("%s\n","  -W, --width=INT           Width of rendered frames in pixels  (default=\n                              `800')");
  printf("%s\n","  -H, --height=INT          Height of rendered frames in pixels  (default=\n                              `600')");
  printf("%s\n","  -b, --basename=STRING     Basename to use when creating output files  \n                              (default=`moose_poop-')");
  printf("%s\n","  -k, --keys                Dump the hot keys list that work inside the viewer");
  printf("%s\n","  -l, --list                List the output file formats available for dumping \n                              images");
  printf("%s\n","  -t, --type=STRING         File format to write rendered files too.  See \n                              --list for file types  (default=`png')");
  printf("%s\n","  -w, --waypoints=filename  Load in waypoints from a file");
  printf("%s\n","  -i, --interval=sec        Minimum time between each frame in animating  \n                              (default=`0.25')");
  printf("%s\n","  -p, --percent=FLOAT       Fraction to move between each waypoint after each \n                              frame [0..1].  It is recommended to use an even \n                              divisor of 1.0 or your animation will jump at \n                              each waypoint  (default=`0.1')");
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  
  int i;
  if (args_info->basename_arg)
    {
      free (args_info->basename_arg); /* free previous argument */
      args_info->basename_arg = 0;
    }
  if (args_info->type_arg)
    {
      free (args_info->type_arg); /* free previous argument */
      args_info->type_arg = 0;
    }
  if (args_info->waypoints_arg)
    {
      free (args_info->waypoints_arg); /* free previous argument */
      args_info->waypoints_arg = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  
  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);
  
  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "verbosity",	1, NULL, 'v' },
        { "width",	1, NULL, 'W' },
        { "height",	1, NULL, 'H' },
        { "basename",	1, NULL, 'b' },
        { "keys",	0, NULL, 'k' },
        { "list",	0, NULL, 'l' },
        { "type",	1, NULL, 't' },
        { "waypoints",	1, NULL, 'w' },
        { "interval",	1, NULL, 'i' },
        { "percent",	1, NULL, 'p' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVv:W:H:b:klt:w:i:p:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'v':	/* Set the verbosity level (0=quiet 10=verbose 20=bombastic).  */
          if (local_args_info.verbosity_given)
            {
              fprintf (stderr, "%s: `--verbosity' (`-v') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->verbosity_given && ! override)
            continue;
          local_args_info.verbosity_given = 1;
          args_info->verbosity_given = 1;
          args_info->verbosity_arg = strtol (optarg,&stop_char,0);
          break;

        case 'W':	/* Width of rendered frames in pixels.  */
          if (local_args_info.width_given)
            {
              fprintf (stderr, "%s: `--width' (`-W') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->width_given && ! override)
            continue;
          local_args_info.width_given = 1;
          args_info->width_given = 1;
          args_info->width_arg = strtol (optarg,&stop_char,0);
          break;

        case 'H':	/* Height of rendered frames in pixels.  */
          if (local_args_info.height_given)
            {
              fprintf (stderr, "%s: `--height' (`-H') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->height_given && ! override)
            continue;
          local_args_info.height_given = 1;
          args_info->height_given = 1;
          args_info->height_arg = strtol (optarg,&stop_char,0);
          break;

        case 'b':	/* Basename to use when creating output files.  */
          if (local_args_info.basename_given)
            {
              fprintf (stderr, "%s: `--basename' (`-b') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->basename_given && ! override)
            continue;
          local_args_info.basename_given = 1;
          args_info->basename_given = 1;
          if (args_info->basename_arg)
            free (args_info->basename_arg); /* free previous string */
          args_info->basename_arg = gengetopt_strdup (optarg);
          break;

        case 'k':	/* Dump the hot keys list that work inside the viewer.  */
          if (local_args_info.keys_given)
            {
              fprintf (stderr, "%s: `--keys' (`-k') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->keys_given && ! override)
            continue;
          local_args_info.keys_given = 1;
          args_info->keys_given = 1;
          break;

        case 'l':	/* List the output file formats available for dumping images.  */
          if (local_args_info.list_given)
            {
              fprintf (stderr, "%s: `--list' (`-l') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->list_given && ! override)
            continue;
          local_args_info.list_given = 1;
          args_info->list_given = 1;
          break;

        case 't':	/* File format to write rendered files too.  See --list for file types.  */
          if (local_args_info.type_given)
            {
              fprintf (stderr, "%s: `--type' (`-t') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->type_given && ! override)
            continue;
          local_args_info.type_given = 1;
          args_info->type_given = 1;
          if (args_info->type_arg)
            free (args_info->type_arg); /* free previous string */
          args_info->type_arg = gengetopt_strdup (optarg);
          break;

        case 'w':	/* Load in waypoints from a file.  */
          if (local_args_info.waypoints_given)
            {
              fprintf (stderr, "%s: `--waypoints' (`-w') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->waypoints_given && ! override)
            continue;
          local_args_info.waypoints_given = 1;
          args_info->waypoints_given = 1;
          if (args_info->waypoints_arg)
            free (args_info->waypoints_arg); /* free previous string */
          args_info->waypoints_arg = gengetopt_strdup (optarg);
          break;

        case 'i':	/* Minimum time between each frame in animating.  */
          if (local_args_info.interval_given)
            {
              fprintf (stderr, "%s: `--interval' (`-i') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->interval_given && ! override)
            continue;
          local_args_info.interval_given = 1;
          args_info->interval_given = 1;
          args_info->interval_arg = (float)strtod (optarg, NULL);
          break;

        case 'p':	/* Fraction to move between each waypoint after each frame [0..1].  It is recommended to use an even divisor of 1.0 or your animation will jump at each waypoint.  */
          if (local_args_info.percent_given)
            {
              fprintf (stderr, "%s: `--percent' (`-p') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->percent_given && ! override)
            continue;
          local_args_info.percent_given = 1;
          args_info->percent_given = 1;
          args_info->percent_arg = (float)strtod (optarg, NULL);
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
    }

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
  
      args_info->inputs_num = argc - optind ;
      args_info->inputs = 
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ; 
    }
  
  return 0;

failure:
  cmdline_parser_free (&local_args_info);
  return (EXIT_FAILURE);
}
